settings = {}

Document = renoise.Document.create("R3z0n4t0r"){
  name="",
  samplerate=3,
  bits=2,
  gauss_rnd=4,
  tunning=2,
  render=1,
  beta=0.1,
  t60=4.0,
  B=0.5,
  p=0.0,
  RC_f0=8,
  RC_dt=0.0001,
  noise_source=1,
  filter=1,
  filter_frequency=1000,
  filter_quality=10,
  filter_gain=1,
  filter_wet=0.5,
  damping_filter = 3,
  selected_note=1,
  selected_octave=4,
  duration=1,
  crop=0.5,
  chnote_1=7,
  chnote_1_oct=1,
  chnote_1_on=false,
  chnote_2=12,
  chnote_2_oct=1,
  chnote_2_on=false,
  chnote_3=5,
  chnote_3_oct=2,
  chnote_3_on=false,
  chnote_4=10,
  chnote_4_oct=2,
  chnote_4_on=false,
  chnote_5=3,
  chnote_5_oct=2,
  chnote_5_on=false,
  chnote_6=8,
  chnote_6_oct=3,
  chnote_6_on=false,
  chnote_7=12,
  chnote_7_oct=4,
  chnote_7_on=false,
  chnote_8=5,
  chnote_8_oct=4,
  chnote_8_on=false,
  sample_autorender=false,
  sample_loop=1,
  stroke=1,
  string_delay=5,
  sample_revert=false,
}

function fill_settings_and_gui()
  settings.name             = Document.name.value
  settings.samplerate       = Document.samplerate.value
  settings.bits             = Document.bits.value
  settings.gauss_rnd        = Document.gauss_rnd.value
  settings.tunning          = Document.tunning.value
  settings.render           = Document.render.value
  settings.beta             = Document.beta.value
  settings.t60              = Document.t60.value
  settings.B                = Document.B.value
  settings.p                = Document.p.value
  settings.RC_f0            = Document.RC_f0.value
  settings.RC_dt            = Document.RC_dt.value
  settings.noise_source     = Document.noise_source.value
  settings.filter           = Document.filter.value
  settings.filter_frequency = Document.filter_frequency.value
  settings.filter_quality   = Document.filter_quality.value
  settings.filter_gain      = Document.filter_gain.value
  settings.filter_wet       = Document.filter_wet.value
  settings.damping_filter   = Document.damping_filter.value
  settings.selected_note    = Document.selected_note.value
  settings.selected_octave  = Document.selected_octave.value
  settings.duration         = Document.duration.value
  settings.crop             = Document.crop.value
  settings.chnote_1         = Document.chnote_1.value
  settings.chnote_1_oct     = Document.chnote_1_oct.value +1
  settings.chnote_1_on      = Document.chnote_1_on.value
  settings.chnote_2         = Document.chnote_2.value
  settings.chnote_2_oct     = Document.chnote_2_oct.value+1
  settings.chnote_2_on      = Document.chnote_2_on.value
  settings.chnote_3         = Document.chnote_3.value
  settings.chnote_3_oct     = Document.chnote_3_oct.value+1
  settings.chnote_3_on      = Document.chnote_3_on.value
  settings.chnote_4         = Document.chnote_4.value
  settings.chnote_4_oct     = Document.chnote_4_oct.value+1
  settings.chnote_4_on      = Document.chnote_4_on.value
  settings.chnote_5         = Document.chnote_5.value
  settings.chnote_5_oct     = Document.chnote_5_oct.value+1
  settings.chnote_5_on      = Document.chnote_5_on.value
  settings.chnote_6         = Document.chnote_6.value
  settings.chnote_6_oct     = Document.chnote_6_oct.value+1
  settings.chnote_6_on      = Document.chnote_6_on.value
  settings.chnote_7         = Document.chnote_7.value
  settings.chnote_7_oct     = Document.chnote_7_oct.value+1
  settings.chnote_7_on      = Document.chnote_7_on.value
  settings.chnote_8         = Document.chnote_8.value
  settings.chnote_8_oct     = Document.chnote_8_oct.value+1
  settings.chnote_8_on      = Document.chnote_8_on.value
  settings.sample_autorender= Document.sample_autorender.value
  settings.sample_loop      = Document.sample_loop.value
  settings.stroke           = Document.stroke.value
  settings.string_delay     = Document.string_delay.value
  settings.sample_revert    = Document.sample_revert.value


  vbs.samplerate.value              = settings.samplerate
  vbs.bits.value                    = settings.bits
  vbs.gauss_rnd.value               = settings.gauss_rnd
  vbs.tunning.value                 = settings.tunning
  vbs.render.value                  = settings.render
  vbs.beta_slider.value             = settings.beta
  --vbs.beta_box.value                = settings.beta
  vbs.t60_slider.value              = settings.t60
  --vbs.t60_box.value                 = settings.t60
  vbs.b_slider.value                = settings.B
  --vbs.b_box.value                   = settings.B
  vbs.p_slider.value                = settings.p
  --vbs.p_box.value                   = settings.p
  vbs.RC_f_slider.value             = settings.RC_f0
  --vbs.RC_f_box.value                = settings.RC_f0
  vbs.RC_dt_slider.value            = settings.RC_dt
  --vbs.RC_dt_box.value               = settings.RC_dt
  vbs.noise_source.value            = settings.noise_source
  vbs.filter.value                  = settings.filter
  vbs.filter_frequency_slider.value = settings.filter_frequency
  --vbs.filter_frequency_box.value    = settings.filter_frequency
  vbs.filter_quality_slider.value   = settings.filter_quality
  --vbs.filter_quality_box.value      = settings.filter_quality
  vbs.filter_gain_slider.value      = settings.filter_gain
  --vbs.filter_gain_box.value         = settings.filter_gain
  vbs.filter_wet_slider.value       = settings.filter_wet
  --vbs.filter_wet_box.value          = settings.filter_wet
  vbs.damping_filter.value          = settings.damping_filter
  vbs.selected_note.value           = settings.selected_note
  vbs.selected_octave.value         = settings.selected_octave
  vbs.crop_slider.value             = settings.crop
  vbs.crop_box.value                = settings.crop
  vbs.chnote_1.value                = settings.chnote_1
  vbs.chnote_1_oct.value            = settings.chnote_1_oct
  vbs.chnote_1_on.value             = settings.chnote_1_on
  vbs.chnote_2.value                = settings.chnote_2
  vbs.chnote_2_oct.value            = settings.chnote_2_oct
  vbs.chnote_2_on.value             = settings.chnote_2_on
  vbs.chnote_3.value                = settings.chnote_3
  vbs.chnote_3_oct.value            = settings.chnote_3_oct
  vbs.chnote_3_on.value             = settings.chnote_3_on
  vbs.chnote_4.value                = settings.chnote_4
  vbs.chnote_4_oct.value            = settings.chnote_4_oct
  vbs.chnote_4_on.value             = settings.chnote_4_on
  vbs.chnote_5.value                = settings.chnote_5
  vbs.chnote_5_oct.value            = settings.chnote_5_oct
  vbs.chnote_5_on.value             = settings.chnote_5_on
  vbs.chnote_6.value                = settings.chnote_6
  vbs.chnote_6_oct.value            = settings.chnote_6_oct
  vbs.chnote_6_on.value             = settings.chnote_6_on
  vbs.chnote_7.value                = settings.chnote_7
  vbs.chnote_7_oct.value            = settings.chnote_7_oct
  vbs.chnote_7_on.value             = settings.chnote_7_on
  vbs.chnote_8.value                = settings.chnote_8
  vbs.chnote_8_oct.value            = settings.chnote_8_oct
  vbs.chnote_8_on.value             = settings.chnote_8_on
  vbs.sample_autorender.value       = settings.sample_autorender
  vbs.sample_loop.value             = settings.sample_loop
  vbs.stroke.value                  = settings.stroke
  vbs.string_delay.value            = settings.string_delay
  vbs.sample_revert.value           = settings.sample_revert

end

function fill_document()
  Document.name.value             = settings.name
  Document.samplerate.value       = settings.samplerate
  Document.bits.value             = settings.bits
  Document.gauss_rnd.value        = settings.gauss_rnd
  Document.tunning.value          = settings.tunning
  Document.render.value           = settings.render
  Document.beta.value             = settings.beta
  Document.t60.value              = settings.t60
  Document.B.value                = settings.B
  Document.p.value                = settings.p
  Document.RC_f0.value            = settings.RC_f0
  Document.RC_dt.value            = settings.RC_dt
  Document.noise_source.value     = settings.noise_source
  Document.filter.value           = settings.filter
  Document.filter_frequency.value = settings.filter_frequency
  Document.filter_quality.value   = settings.filter_quality
  Document.filter_gain.value      = settings.filter_gain
  Document.filter_wet.value       = settings.filter_wet
  Document.damping_filter.value   = settings.damping_filter
  Document.selected_note.value    = settings.selected_note
  Document.selected_octave.value  = settings.selected_octave
  Document.duration.value         = settings.duration
  Document.crop.value             = settings.crop
  Document.chnote_1.value         = settings.chnote_1
  Document.chnote_1_oct.value     = settings.chnote_1_oct
  Document.chnote_1_on.value      = settings.chnote_1_on
  Document.chnote_2.value         = settings.chnote_2
  Document.chnote_2_oct.value     = settings.chnote_2_oct
  Document.chnote_2_on.value      = settings.chnote_2_on
  Document.chnote_3.value         = settings.chnote_3
  Document.chnote_3_oct.value     = settings.chnote_3_oct
  Document.chnote_3_on.value      = settings.chnote_3_on
  Document.chnote_4.value         = settings.chnote_4
  Document.chnote_4_oct.value     = settings.chnote_4_oct
  Document.chnote_4_on.value      = settings.chnote_4_on
  Document.chnote_5.value         = settings.chnote_5
  Document.chnote_5_oct.value     = settings.chnote_5_oct
  Document.chnote_5_on.value      = settings.chnote_5_on
  Document.chnote_6.value         = settings.chnote_6
  Document.chnote_6_oct.value     = settings.chnote_6_oct
  Document.chnote_6_on.value      = settings.chnote_6_on
  Document.chnote_7.value         = settings.chnote_7
  Document.chnote_7_oct.value     = settings.chnote_7_oct
  Document.chnote_7_on.value      = settings.chnote_7_on
  Document.chnote_8.value         = settings.chnote_8
  Document.chnote_8_oct.value     = settings.chnote_8_oct
  Document.chnote_8_on.value      = settings.chnote_8_on
  Document.sample_autorender.value= settings.sample_autorender
  Document.sample_loop.value      = settings.sample_loop
  Document.stroke.value           = settings.stroke
  Document.string_delay.value     = settings.string_delay
  Document.sample_revert.value    = settings.sample_revert
end